<?php
/**
* Sound Direct Manager 
* @package project
* @author Wizard <sergejey@gmail.com>
* @copyright http://majordomo.smartliving.ru/ (c)
* @version 2.2 (wizard, 01:02:05 [Feb 11, 2017])
* @author Wizard <sergejey@gmail.com>
* @author project Bagir <sk1510@mail.ru>
* @version project 2.0
*/
//
//
class sdm extends module {
/**
* sdm
*
* Module class constructor
*
* @access private
*/
function sdm() {
  $this->name="sdm";
  $this->title="Sound Direct Manager";
  $this->module_category="<#LANG_SECTION_APPLICATIONS#>";
  $this->checkInstalled();
}
/**
* saveParams
*
* Saving module parameters
*
* @access public
*/
function saveParams($data=0) {
 $p=array();
 if (IsSet($this->id)) {
  $p["id"]=$this->id;
 }
 if (IsSet($this->view_mode)) {
  $p["view_mode"]=$this->view_mode;
 }
 if (IsSet($this->edit_mode)) {
  $p["edit_mode"]=$this->edit_mode;
 }
 if (IsSet($this->tab)) {
  $p["tab"]=$this->tab;
 }
 return parent::saveParams($p);
}
/**
* getParams
*
* Getting module parameters from query string
*
* @access public
*/
function getParams() {
  global $id;
  global $mode;
  global $view_mode;
  global $edit_mode;
  global $tab;
  if (isset($id)) {
   $this->id=$id;
  }
  if (isset($mode)) {
   $this->mode=$mode;
  }
  if (isset($view_mode)) {
   $this->view_mode=$view_mode;
  }
  if (isset($edit_mode)) {
   $this->edit_mode=$edit_mode;
  }
  if (isset($tab)) {
   $this->tab=$tab;
  }
}
/**
* Run
*
* Description
*
* @access public
*/
function run() {
 global $session;
  $out=array();
  if ($this->action=='admin') {
   $this->admin($out);
  } else {
   $this->usual($out);
  }
  if (IsSet($this->owner->action)) {
   $out['PARENT_ACTION']=$this->owner->action;
  }
  if (IsSet($this->owner->name)) {
   $out['PARENT_NAME']=$this->owner->name;
  }
  $out['VIEW_MODE']=$this->view_mode;
  $out['EDIT_MODE']=$this->edit_mode;
  $out['MODE']=$this->mode;
  $out['ACTION']=$this->action;
  $out['TAB']=$this->tab;
  $this->data=$out;
  $p=new parser(DIR_TEMPLATES.$this->name."/".$this->name.".html", $this->data, $this);
  $this->result=$p->result;
}
/**
* BackEnd
*
* Module backend
*
* @access public
*/
function admin(&$out) {
 $this->getConfig();
 $out['SAY_ENABLE']=$this->config['SAY_ENABLE'];
 $out['SAYTO_ENABLE']=$this->config['SAYTO_ENABLE'];
 $out['NIGHT_OP']=$this->config['NIGHT_OP'];                         if (!$out['NIGHT_OP']) { $out['NIGHT_OP']='NightMode.status';  }
 $out['NIGHT_PERCENT']=$this->config['NIGHT_PERCENT'];
 $out['NIGHTMODE_ENABLE']=$this->config['NIGHTMODE_ENABLE'];
 $out['MINLVL_VOLUP']=$this->config['MINLVL_VOLUP'];
 $out['MINLVL_ALARM']=$this->config['MINLVL_ALARM'];
 $out['ALARM_CODE']=$this->config['ALARM_CODE'];
 $out['DEBMES_ENABLE']=$this->config['DEBMES_ENABLE'];


 if ($this->view_mode=='update_settings') {
   global $say_enable;
   $this->config['SAY_ENABLE']=(int)$say_enable;

   global $sayto_enable;
   $this->config['SAYTO_ENABLE']=(int)$sayto_enable;

   global $nightMode_op;
   $this->config['NIGHT_OP']=$nightMode_op;

   global $nightPercent;   
   if ($nightPercent) {
   $this->config['NIGHT_PERCENT']=(int)$nightPercent;
   } else {
   $this->config['NIGHT_PERCENT']=NULL;
   }

   global $nightMode_enable;
   $this->config['NIGHTMODE_ENABLE']=(int)$nightMode_enable;

   global $minlvl_volup;
   if ($minlvl_volup) {
   $this->config['MINLVL_VOLUP']=(int)$minlvl_volup;
   } else {
   $this->config['MINLVL_VOLUP']=NULL;
   }

   global $minlvl_alarm;
   if ($minlvl_alarm) {
   $this->config['MINLVL_ALARM']=(int)$minlvl_alarm;
   } else {
   $this->config['MINLVL_ALARM']=NULL;
   }

   global $alarm_code;
   $this->config['ALARM_CODE']=$alarm_code;

   global $debmes_enable;
   $this->config['DEBMES_ENABLE']=(int)$debmes_enable;

   $this->saveConfig();
   $this->redirect("?");
 }

 if (isset($this->data_source) && !$_GET['data_source'] && !$_POST['data_source']) {
  $out['SET_DATASOURCE']=1;
 }
 if ($this->data_source=='sdm' || $this->data_source=='') {
  if ($this->view_mode=='' || $this->view_mode=='search_sdm') {
   $this->search_sdm($out);
  }
  if ($this->view_mode=='edit_sdm') {
   $this->edit_sdm($out, $this->id);
  }
  if ($this->view_mode=='delete_sdm') {
   $this->delete_sdm($this->id);
   $this->redirect("?");
  }
 }
}
/**
* FrontEnd
*
* Module frontend
*
* @access public
*/
function usual(&$out) {
 $this->admin($out);
}
/**
* sdm search
*
* @access public
*/
 function search_sdm(&$out) {
  require(DIR_MODULES.$this->name.'/sdm_search.inc.php');
 }
/**
* sdm edit/add
*
* @access public
*/
 function edit_sdm(&$out, $id) {
  require(DIR_MODULES.$this->name.'/sdm_edit.inc.php');
 }
/**
* sdm delete record
*
* @access public
*/
 function delete_sdm($id) {
  $rec=SQLSelectOne("SELECT * FROM sdm WHERE ID='$id'");
  // some action for related tables
  SQLExec("DELETE FROM sdm WHERE ID='".$rec['ID']."'");
 }


/*  
 *    Подписка на события SAY и SAYTO
 *    получает в параметрах
 *    $event = 'SAY' или 'SAYTO'
 *    $details[] массив
 *      level - уровень важности
 *      message - Сообщение с текстом или именем файла
 *      destination - Номер канала или пусто для общих сообщений.
 */
function processSubscription($event, $details='') {
 $this->getConfig();
 $debmes_enable=$this->config['DEBMES_ENABLE'];
 if ($debmes_enable) { debmes('SDM:debug => received '.$event.' details='.json_encode($details)); }

 if ($event=='SAY' && $this->config['SAY_ENABLE']) {
  $details['destination'] = '';
  $this->setTask( $details );
 }

 if ($event=='SAYTO' && $this->config['SAYTO_ENABLE']) {
  $this->setTask( $details );
 }
}


/**
* Сборка атрибутов в соответствии со значением $level и $destination
* и вызов sendCommand
*/
function setTask ($details='') {

 if ( !is_array($details) ) {debmes('SDM:error => функции setTask не передан массив $details');  return;} 

 /*  Костыль для передачи параметра marker через message
     если $message содержит -marker то передать его в массив и вырезать из $message
 */
 $matches=[];
 preg_match('/(\Smarker:)(\S+)( )/', $details['message'], $matches);
 if (count($matches)) {
   $details['marker']=$matches[2];
   $details['message']= str_replace($matches[0], '', $details['message']);
 }

 // Получить значение с формы. Возможно есть другой вариант. todo
 $this->getConfig();
 $say_enable= $this->config['SAY_ENABLE'];
 $sayto_enable=$this->config['SAYTO_ENABLE'];
 $nightMode_op=$this->config['NIGHT_OP'];
 $nightPercent=$this->config['NIGHT_PERCENT'];
 $nightMode_enable=$this->config['NIGHTMODE_ENABLE'];
 $minlvl_volup=(int)$this->config['MINLVL_VOLUP'];
 $minlvl_alarm=(int)$this->config['MINLVL_ALARM'];
 $alarm_code=$this->config['ALARM_CODE'];
 $debmes_enable=$this->config['DEBMES_ENABLE'];

 // Проще использовать
 $message = $details['message'];
 $level = $details['level'];
 $destination = $details['destination'];

 $atr='';
 if ($level<0) {
   // завершить работу. Сообщение будет написанно только в чате
   return;
 } elseif ($level==0) {
   // общие не тревожные сообщения ночью приглушаются ($destination тут либо место либо '')  // исправления. 'all' заменен на ''
   if ($nightPercent && $nightMode_op && $destination ) {
    if (gg($nightMode_op)) { $atr="-volumemessage:$nightPercent "; }
   }
   // общие не тревожные сообщения ночью переадресуются на указанный канал
   if (nightMode_enable && $nightMode_op && $destination == '' ) {
    if (gg($nightMode_op)) { $destination='NIGHTCHANNEL'; }
   }
 }
 if ($level>=$minlvl_volup && $minlvl_volup) {
   // громкость на максимум для тревожных сообщений.
   $atr='-volumemessage:100 ';
 }
 if ($level>=$minlvl_alarm && $minlvl_alarm) {
   // Выполнить тревожный код
   if ($alarm_code) { eval($alarm_code); }
 }

 if ($debmes_enable) { debmes('SDM:debug => Adding attributes atr='.$atr); }
 
 if ($destination) {
   // Получить все маршруты канала
   $devices=SQLSelect("SELECT * FROM sdm WHERE UPPER(DESTINATION)=UPPER('$destination')");
 } else {
   // Получить все уникальные адреса серверов
   $devices=SQLSelect("SELECT DISTINCT SERVER_IP, TEMPORARY FROM sdm");
 }
 $arrans=[]; // массив всех ответов 
 $total=count($devices);
 if ($debmes_enable) { debmes('SDM:debug => Receive '.$total.' routes'); }
 for ($i=0;$i<$total;$i++) {
   $srv=$devices[$i]['SERVER_IP'];
   if (strpos($srv,'://')===false) { $srv="http://".$srv; }
   $url=$srv.'/';
   if ($destination) {
    if ($devices[$i]['CHANNEL']) { $url.='-outputchannel:'.$devices[$i]['CHANNEL'].' '; }
    // if ($devices[$i]['DEVICE']) { $url.='-outputdevice:'.$devices[$i]['DEVICE'].' '; }
   }
   $url.=$atr.urlencode($message);
   // Отправить задачу на SDM сервер 
   // второй параметр это время ожидания ответа. Для не постоянных серверов 1 секунда, иначе 2 сек
   $ans=$this->sendCommand($url, ($devices[$i]['TEMPORARY'] ? 1 : 2));
   // Зарегистрировать ошибку, если ответ не получен и сервер не временный
   if (!$ans && !$devices[$i]['TEMPORARY']) { 
    registerError('sdm', 'No answer from '.$srv);
    say('Нет ответа от системы синтеза речи', -1);
   }
   // накоплене ответов со всех маршрутов
   $arrans[]=$ans;
 }

 // Добавить в массив ответ всех маршрутов и вернуть Алисе
 $details['response']=$arrans;
 cm('ThisComputer.SDMresponse', array('details'=>$details));
 return implode(';', $arrans);
}


/*
* Отправка задачи на сервер SDM
*
*/
function sendCommand($url, $timeout=2) {
 $this->getConfig();
 $debmes_enable=$this->config['DEBMES_ENABLE'];

 if (!$url) {debmes('SDM:error => not set text');  return;}
 // передача данных через TCP порт
 // Ждать ответа от sdm не больше 2 секунд
 $ctx = stream_context_create(array('http'=>array('timeout'=>$timeout) ) ); 
 // Журнал
 if ($debmes_enable) { debmes( 'SDM:debug => Sent Message to SDM '.$url ); }
 // Отправка принимающей программе (программе SDM)
 $ans = trim( file_get_contents($url, 0, $ctx) );
 if ($debmes_enable) { debmes( 'SDM:debug => Receive Message from SDM '.$ans ); }
 // Возврат ответа
 return $ans;
}


/**
* Install
*
* Module installation routine
*
* @access private
*/
 function install($data='') {
  subscribeToEvent($this->name, 'SAY');
  subscribeToEvent($this->name, 'SAYTO');
  parent::install();
 }
/**
* Uninstall
*
* Module uninstall routine
*
* @access public
*/
 function uninstall() {
  SQLExec('DROP TABLE IF EXISTS sdm');
  parent::uninstall();
 }
/**
* dbInstall
*
* Database installation routine
*
* @access private
*/
 function dbInstall() {
/*
sdm - 
*/
  $data = <<<EOD
 sdm: ID int(10) unsigned NOT NULL auto_increment
 sdm: TITLE varchar(100) NOT NULL DEFAULT ''
 sdm: DESTINATION varchar(100) NOT NULL DEFAULT ''
 sdm: SERVER_IP varchar(20) NOT NULL DEFAULT ''
 sdm: DEVICE_ID varchar(10) NOT NULL DEFAULT ''
 sdm: CHANNEL varchar(10) NOT NULL DEFAULT ''
 sdm: TEMPORARY tinyint(1) default NULL
EOD;
  parent::dbInstall($data);
 }
// --------------------------------------------------------------------
}
/*
*
* TW9kdWxlIGNyZWF0ZWQgRmViIDExLCAyMDE3IHVzaW5nIFNlcmdlIEouIHdpemFyZCAoQWN0aXZlVW5pdCBJbmMgd3d3LmFjdGl2ZXVuaXQuY29tKQ==
*
*/
